--
-- Written by peinzser
--

-- Initialize the addon
local addonName, addon = ...
local hbd = LibStub("HereBeDragons-1.0")
addon = LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceConsole-3.0", "AceEvent-3.0")

-- Extract version from TOC file
addon.version = GetAddOnMetadata(addonName, "Version")
addon.title = GetAddOnMetadata(addonName, "Title")
addon.author = GetAddOnMetadata(addonName, "Author")

-- Reference name
local Buzzbox = addon

-- Addon defaults
Buzzbox.defaults = {
  profile = {
    minimap = {
      hide = false
    },
    tfreq = 999,
    encryptionKey = "0",
    encryptionopt = false,
    sendernameopt = 1,
    senderRPnameopt = true,
    noiseopt = true,
    volume = 1,
    maxdistance = 1500,
    devicename = "Buzzbox",
  },
}

--  --------------------------
--      Sending a message
--  --------------------------

function Buzzbox:CHAT_MSG_SAY(event, message, sender_realm)
  if self:MicrophoneActive() then
    if self.id == nil then self.id = GetChannelName("xtensionxtooltip2") end
    if self.rpname == nil then self.rpname = self:GetRPName() end -- if not done so already, get player's IC name
    local sender = self:RemoveServer(sender_realm) -- remove realm from name
    local px, py, instanceID = hbd:GetPlayerWorldPosition()

    if sender == self.pname then
      local encKey = self:GetEncryptionKey()
      -- protocol
      SendChatMessage("BZBP3"..self.db.profile.tfreq.." "..encKey.." "..px.." "..py.." "..self.rpname.."", "CHANNEL", nil, self.id)
      SendChatMessage("BZB3"..self.db.profile.tfreq..""..instanceID.." "..message.."", "CHANNEL", nil, self.id);
    end
  end
end

--  ----------------------------
--      Receiving a message
--  ----------------------------

function Buzzbox:CHAT_MSG_CHANNEL(event, message, sender_realm)
  if self.status == 1 then
    local sender = self:RemoveServer(sender_realm) -- remove realm from name
    if sender ~= self.pname then
      -- Needed variables
      local px, py, instanceID = hbd:GetPlayerWorldPosition(); -- get player's position
      firstWord, restOfString = message:match("(%w+)(.+)") -- seperate first word from the rest of the message
      local encKey = self:GetEncryptionKey()

      --  ----------------------------------
      --      For versions 1.3 and newer
      --  ----------------------------------

      -- String containing encryption key, name and position
      if firstWord == "BZBP3"..self.db.profile.tfreq.."" then -- extract message data
        words, wordc = self:BreakStringIntoWords(restOfString)
        self.encryptionKeyReceived = words[1] -- encryption
        self.angle, self.distance = hbd:GetWorldVector(instanceID, px, py, tonumber(words[2]), tonumber(words[3]));
        self.senderRPname = self:GetSenderRPName(words,wordc) -- take the words remaining and combine them to make the IC name
      end

      -- String containing the actual message
      if firstWord == "BZB3"..self.db.profile.tfreq..""..instanceID.."" and self.distance <= self.db.profile.maxdistance and encKey == self.encryptionKeyReceived then -- emote the received message
        -- Insert noise in message
        if self.db.profile.noiseopt == true then
          restOfString = self:InsertCrackles(restOfString)
        end
        -- Print IC or OOC name
        if self.senderRPname ~= nil and self.db.profile.senderRPnameopt == true then
          self:PrintMessage(restOfString, self.senderRPname)
        else
          self:PrintMessage(restOfString, sender)
        end
      end

    --  ----------------------------------
    --      For versions 1.2 and older
    --  ----------------------------------

      if firstWord == "BZBP"..self.db.profile.tfreq..""..instanceID.."" then -- OLD VERSIONS
        words, wordc = self:BreakStringIntoWords(restOfString)
        self.angle, self.distance = hbd:GetWorldVector(instanceID, px, py, tonumber(words[2]), tonumber(words[3]));
      end

      if firstWord == "BZB"..self.db.profile.tfreq..""..instanceID.."" and self.distance <= self.db.profile.maxdistance then -- emote the received message
        if self.db.profile.noiseopt == 1 then -- replace words with crackles
            restOfString = self:InsertCrackles(restOfString)
        end
        self:PrintMessage(restOfString, sender)
      end
    end
  end
end
